<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/textwrap-0.15.0/src/indentation.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>indentation.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../textwrap/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
</pre><pre class="rust"><code><span class="doccomment">//! Functions related to adding and removing indentation from lines of</span>
<span class="doccomment">//! text.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The functions here can be used to uniformly indent or dedent</span>
<span class="doccomment">//! (unindent) word wrapped lines of text.</span>

<span class="doccomment">/// Indent each line by the given prefix.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::indent;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(indent(&quot;First line.\nSecond line.\n&quot;, &quot;  &quot;),</span>
<span class="doccomment">///            &quot;  First line.\n  Second line.\n&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// When indenting, trailing whitespace is stripped from the prefix.</span>
<span class="doccomment">/// This means that empty lines remain empty afterwards:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::indent;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(indent(&quot;First line.\n\n\nSecond line.\n&quot;, &quot;  &quot;),</span>
<span class="doccomment">///            &quot;  First line.\n\n\n  Second line.\n&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Notice how `&quot;\n\n\n&quot;` remained as `&quot;\n\n\n&quot;`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This feature is useful when you want to indent text and have a</span>
<span class="doccomment">/// space between your prefix and the text. In this case, you _don&#39;t_</span>
<span class="doccomment">/// want a trailing space on empty lines:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::indent;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(indent(&quot;foo = 123\n\nprint(foo)\n&quot;, &quot;# &quot;),</span>
<span class="doccomment">///            &quot;# foo = 123\n#\n# print(foo)\n&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Notice how `&quot;\n\n&quot;` became `&quot;\n#\n&quot;` instead of `&quot;\n# \n&quot;` which</span>
<span class="doccomment">/// would have trailing whitespace.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Leading and trailing whitespace coming from the text itself is</span>
<span class="doccomment">/// kept unchanged:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::indent;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(indent(&quot; \t  Foo   &quot;, &quot;-&gt;&quot;), &quot;-&gt; \t  Foo   &quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">indent</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">prefix</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">String</span> {
    <span class="comment">// We know we&#39;ll need more than s.len() bytes for the output, but</span>
    <span class="comment">// without counting &#39;\n&#39; characters (which is somewhat slow), we</span>
    <span class="comment">// don&#39;t know exactly how much. However, we can preemptively do</span>
    <span class="comment">// the first doubling of the output size.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span> <span class="op">=</span> <span class="ident">String::with_capacity</span>(<span class="number">2</span> <span class="op">*</span> <span class="ident">s</span>.<span class="ident">len</span>());
    <span class="kw">let</span> <span class="ident">trimmed_prefix</span> <span class="op">=</span> <span class="ident">prefix</span>.<span class="ident">trim_end</span>();
    <span class="kw">for</span> (<span class="ident">idx</span>, <span class="ident">line</span>) <span class="kw">in</span> <span class="ident">s</span>.<span class="ident">split_terminator</span>(<span class="string">&#39;\n&#39;</span>).<span class="ident">enumerate</span>() {
        <span class="kw">if</span> <span class="ident">idx</span> <span class="op">&gt;</span> <span class="number">0</span> {
            <span class="ident">result</span>.<span class="ident">push</span>(<span class="string">&#39;\n&#39;</span>);
        }
        <span class="kw">if</span> <span class="ident">line</span>.<span class="ident">trim</span>().<span class="ident">is_empty</span>() {
            <span class="ident">result</span>.<span class="ident">push_str</span>(<span class="ident">trimmed_prefix</span>);
        } <span class="kw">else</span> {
            <span class="ident">result</span>.<span class="ident">push_str</span>(<span class="ident">prefix</span>);
        }
        <span class="ident">result</span>.<span class="ident">push_str</span>(<span class="ident">line</span>);
    }
    <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">ends_with</span>(<span class="string">&#39;\n&#39;</span>) {
        <span class="comment">// split_terminator will have eaten the final &#39;\n&#39;.</span>
        <span class="ident">result</span>.<span class="ident">push</span>(<span class="string">&#39;\n&#39;</span>);
    }
    <span class="ident">result</span>
}

<span class="doccomment">/// Removes common leading whitespace from each line.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function will look at each non-empty line and determine the</span>
<span class="doccomment">/// maximum amount of whitespace that can be removed from all lines:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::dedent;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(dedent(&quot;</span>
<span class="doccomment">///     1st line</span>
<span class="doccomment">///       2nd line</span>
<span class="doccomment">///     3rd line</span>
<span class="doccomment">/// &quot;), &quot;</span>
<span class="doccomment">/// 1st line</span>
<span class="doccomment">///   2nd line</span>
<span class="doccomment">/// 3rd line</span>
<span class="doccomment">/// &quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dedent</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">String</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">prefix</span> <span class="op">=</span> <span class="string">&quot;&quot;</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">lines</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">lines</span>();

    <span class="comment">// We first search for a non-empty line to find a prefix.</span>
    <span class="kw">for</span> <span class="ident">line</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">lines</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">whitespace_idx</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">len</span>();
        <span class="kw">for</span> (<span class="ident">idx</span>, <span class="ident">ch</span>) <span class="kw">in</span> <span class="ident">line</span>.<span class="ident">char_indices</span>() {
            <span class="kw">if</span> <span class="op">!</span><span class="ident">ch</span>.<span class="ident">is_whitespace</span>() {
                <span class="ident">whitespace_idx</span> <span class="op">=</span> <span class="ident">idx</span>;
                <span class="kw">break</span>;
            }
        }

        <span class="comment">// Check if the line had anything but whitespace</span>
        <span class="kw">if</span> <span class="ident">whitespace_idx</span> <span class="op">&lt;</span> <span class="ident">line</span>.<span class="ident">len</span>() {
            <span class="ident">prefix</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">line</span>[..<span class="ident">whitespace_idx</span>];
            <span class="kw">break</span>;
        }
    }

    <span class="comment">// We then continue looking through the remaining lines to</span>
    <span class="comment">// possibly shorten the prefix.</span>
    <span class="kw">for</span> <span class="ident">line</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">lines</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">whitespace_idx</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">len</span>();
        <span class="kw">for</span> ((<span class="ident">idx</span>, <span class="ident">a</span>), <span class="ident">b</span>) <span class="kw">in</span> <span class="ident">line</span>.<span class="ident">char_indices</span>().<span class="ident">zip</span>(<span class="ident">prefix</span>.<span class="ident">chars</span>()) {
            <span class="kw">if</span> <span class="ident">a</span> <span class="op">!</span><span class="op">=</span> <span class="ident">b</span> {
                <span class="ident">whitespace_idx</span> <span class="op">=</span> <span class="ident">idx</span>;
                <span class="kw">break</span>;
            }
        }

        <span class="comment">// Check if the line had anything but whitespace and if we</span>
        <span class="comment">// have found a shorter prefix</span>
        <span class="kw">if</span> <span class="ident">whitespace_idx</span> <span class="op">&lt;</span> <span class="ident">line</span>.<span class="ident">len</span>() <span class="op">&amp;&amp;</span> <span class="ident">whitespace_idx</span> <span class="op">&lt;</span> <span class="ident">prefix</span>.<span class="ident">len</span>() {
            <span class="ident">prefix</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">line</span>[..<span class="ident">whitespace_idx</span>];
        }
    }

    <span class="comment">// We now go over the lines a second time to build the result.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span> <span class="op">=</span> <span class="ident">String::new</span>();
    <span class="kw">for</span> <span class="ident">line</span> <span class="kw">in</span> <span class="ident">s</span>.<span class="ident">lines</span>() {
        <span class="kw">if</span> <span class="ident">line</span>.<span class="ident">starts_with</span>(<span class="kw-2">&amp;</span><span class="ident">prefix</span>) <span class="op">&amp;&amp;</span> <span class="ident">line</span>.<span class="ident">chars</span>().<span class="ident">any</span>(<span class="op">|</span><span class="ident">c</span><span class="op">|</span> <span class="op">!</span><span class="ident">c</span>.<span class="ident">is_whitespace</span>()) {
            <span class="kw">let</span> (<span class="kw">_</span>, <span class="ident">tail</span>) <span class="op">=</span> <span class="ident">line</span>.<span class="ident">split_at</span>(<span class="ident">prefix</span>.<span class="ident">len</span>());
            <span class="ident">result</span>.<span class="ident">push_str</span>(<span class="ident">tail</span>);
        }
        <span class="ident">result</span>.<span class="ident">push</span>(<span class="string">&#39;\n&#39;</span>);
    }

    <span class="kw">if</span> <span class="ident">result</span>.<span class="ident">ends_with</span>(<span class="string">&#39;\n&#39;</span>) <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">s</span>.<span class="ident">ends_with</span>(<span class="string">&#39;\n&#39;</span>) {
        <span class="kw">let</span> <span class="ident">new_len</span> <span class="op">=</span> <span class="ident">result</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>;
        <span class="ident">result</span>.<span class="ident">truncate</span>(<span class="ident">new_len</span>);
    }

    <span class="ident">result</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">indent_empty</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">indent</span>(<span class="string">&quot;\n&quot;</span>, <span class="string">&quot;  &quot;</span>), <span class="string">&quot;\n&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">indent_nonempty</span>() {
        <span class="kw">let</span> <span class="ident">text</span> <span class="op">=</span> [
            <span class="string">&quot;  foo\n&quot;</span>,
            <span class="string">&quot;bar\n&quot;</span>,
            <span class="string">&quot;  baz\n&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;&quot;</span>);
        <span class="kw">let</span> <span class="ident">expected</span> <span class="op">=</span> [
            <span class="string">&quot;//   foo\n&quot;</span>,
            <span class="string">&quot;// bar\n&quot;</span>,
            <span class="string">&quot;//   baz\n&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">indent</span>(<span class="kw-2">&amp;</span><span class="ident">text</span>, <span class="string">&quot;// &quot;</span>), <span class="ident">expected</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">indent_empty_line</span>() {
        <span class="kw">let</span> <span class="ident">text</span> <span class="op">=</span> [
            <span class="string">&quot;  foo&quot;</span>,
            <span class="string">&quot;bar&quot;</span>,
            <span class="string">&quot;&quot;</span>,
            <span class="string">&quot;  baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">expected</span> <span class="op">=</span> [
            <span class="string">&quot;//   foo&quot;</span>,
            <span class="string">&quot;// bar&quot;</span>,
            <span class="string">&quot;//&quot;</span>,
            <span class="string">&quot;//   baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">indent</span>(<span class="kw-2">&amp;</span><span class="ident">text</span>, <span class="string">&quot;// &quot;</span>), <span class="ident">expected</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_empty</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="string">&quot;&quot;</span>), <span class="string">&quot;&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_multi_line</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;    foo&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
            <span class="string">&quot;    baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;  foo&quot;</span>,
            <span class="string">&quot;bar&quot;</span>,
            <span class="string">&quot;  baz&quot;</span>
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_empty_line</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;    foo&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
            <span class="string">&quot;   &quot;</span>,
            <span class="string">&quot;    baz&quot;</span>
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;  foo&quot;</span>,
            <span class="string">&quot;bar&quot;</span>,
            <span class="string">&quot;&quot;</span>,
            <span class="string">&quot;  baz&quot;</span>
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_blank_line</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;      foo&quot;</span>,
            <span class="string">&quot;&quot;</span>,
            <span class="string">&quot;        bar&quot;</span>,
            <span class="string">&quot;          foo&quot;</span>,
            <span class="string">&quot;          bar&quot;</span>,
            <span class="string">&quot;          baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;foo&quot;</span>,
            <span class="string">&quot;&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
            <span class="string">&quot;    foo&quot;</span>,
            <span class="string">&quot;    bar&quot;</span>,
            <span class="string">&quot;    baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_whitespace_line</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;      foo&quot;</span>,
            <span class="string">&quot; &quot;</span>,
            <span class="string">&quot;        bar&quot;</span>,
            <span class="string">&quot;          foo&quot;</span>,
            <span class="string">&quot;          bar&quot;</span>,
            <span class="string">&quot;          baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;foo&quot;</span>,
            <span class="string">&quot;&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
            <span class="string">&quot;    foo&quot;</span>,
            <span class="string">&quot;    bar&quot;</span>,
            <span class="string">&quot;    baz&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_mixed_whitespace</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;\tfoo&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;\tfoo&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_tabbed_whitespace</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;\t\tfoo&quot;</span>,
            <span class="string">&quot;\t\t\tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;foo&quot;</span>,
            <span class="string">&quot;\tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_mixed_tabbed_whitespace</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;\t  \tfoo&quot;</span>,
            <span class="string">&quot;\t  \t\tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;foo&quot;</span>,
            <span class="string">&quot;\tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_mixed_tabbed_whitespace2</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;\t  \tfoo&quot;</span>,
            <span class="string">&quot;\t    \tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;\tfoo&quot;</span>,
            <span class="string">&quot;  \tbar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">fn</span> <span class="ident">dedent_preserve_no_terminating_newline</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> [
            <span class="string">&quot;  foo&quot;</span>,
            <span class="string">&quot;    bar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> [
            <span class="string">&quot;foo&quot;</span>,
            <span class="string">&quot;  bar&quot;</span>,
        ].<span class="ident">join</span>(<span class="string">&quot;\n&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">dedent</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>), <span class="ident">y</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="textwrap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>